#include <QApplication>
#include <QMainWindow>
#include <QMdiArea>
#include <QMdiSubWindow>
#include <QQuickWidget>
#include <QDebug>

class PanelQT : public QWidget
{
public:
    ~PanelQT() { qDebug() << "dtor"; }

    void closeEvent(QCloseEvent *ev)
    {
        ev->accept();
        parentWidget()->close();
        deleteLater();
    }
};

int main(int argc, char **argv)
{
    QApplication app(argc, argv);

    QMainWindow mw;
    QMdiArea *mdiArea = new QMdiArea;
    mdiArea->setOption(QMdiArea::DontMaximizeSubWindowOnActivation);
    mdiArea->setHorizontalScrollBarPolicy(Qt::ScrollBarAsNeeded);
    mdiArea->setVerticalScrollBarPolicy(Qt::ScrollBarAsNeeded);
    mw.setCentralWidget(mdiArea);
    QWidget *panel = new PanelQT;
    panel->resize(500, 500);

    QQuickWidget *quickWidget = new QQuickWidget(panel);  // crashes
    quickWidget->setSource(QUrl("qrc:/main.qml"));
    quickWidget->setResizeMode(QQuickWidget::SizeRootObjectToView);

    //QWidget *quickWidget = new QWidget(panel);  // works
    quickWidget->setGeometry(10, 10, 400, 400);
    QMdiSubWindow *subwindow = mdiArea->addSubWindow(panel);
    subwindow->resize(500, 500);
    subwindow->show();

    mw.show();

    return app.exec();
}
